$(function () {
    //--------------------------------------------[ CREATE THE ALERTBOX SPACE ]
    $("body").append("<div id='errBox'></div>");
});

function errBox(whatIWant) {
    //--------------------------------------------[ DEFAULT PARAMETERS ]

    paramsDefault = {
        type: "danger",
        message: "Test message",
        close: true,
        timer: 3000,
        width: 60,
        glyphicon: false,
        titleMode: false,
        offsetX: 20,
        offsetY: 20,
        hoverOpacity: 0.6
    };
    var params = jQuery.extend(paramsDefault, whatIWant);
    errBoxLaunch(params);
}

function errBoxLaunch(params) {

    var rand_id = "id__" + Math.round(Math.random() * 100000000);

    if (params.close == true) {
        $("#errBox").prepend("<div id='" + rand_id + "' class='alert errBox alert-" + params.type + " alert-dismissible'>" +
            "<button type='button' class='close' data-dismiss='alert' aria-label='Close'>" +
            "<span aria-hidden='true'>&times;</span>" +
            "</button>" +
            glyphIcons(params.glyphicon) +
            params.message +
            "</div>");
    } else {
        $("#errBox").prepend("<div style='opacity: 0;' id='" + rand_id + "' class='alert errBox alert-" + params.type + "'>" + params.message + "</div>");
    }

    if (params.timer != 0) {
        closeBox(params.timer, rand_id);
    }

    if (params.titleMode != true) {
        $("body").off("mousemove");
        $("#errBox").css({
            "position": "fixed",
            "top": "20px",
            "transform": "translate(" + params.posX + ", " + params.posY + ")",
            "width": params.width + "%",
            "left": (100 - params.width) / 2 + "%",
            "z-index": "99999999999999"
        });
        $(".errBox").css({
            "width": "100%"
        });
    } else {
        $("body").on("mousemove", function (event) {
            $("#errBox").css({
                "position": "absolute",
                "dispay": "inline",
                "width": "auto",
                "transform": "translate(0, 0)",
                "top": (event.pageY * 1 + params.offsetY * 1) + "px",
                "left": (event.pageX * 1 + params.offsetX * 1) + "px",
                "z-index": "99999999999999"
            });
            $(".errBox").css({
                "dispay": "inline",
                "width": "100%"
            });
        });
    }

    //--------------------------------------------[ ON HOVER TRANSPARENCY ]
    $(".errBox").on("mouseover", function () {
        $(this).animate({
            "opacity": params.hoverOpacity
        }, 200);
    }).on("mouseleave", function () {
        $(this).animate({
            "opacity": "1"
        }, 200);
    });

    openBox(rand_id);
};

function closeBox(timing, id) {
    setTimeout(function () {
        $("#" + id).animate({
            "opacity": "0",
            "top": "50px"
        }, 500);
        setTimeout(function () {
            $("#" + id).remove();
        }, 500);
    }, timing);

} //--------------------------------------------[ CLOSE BOX ]

function openBox(id) {
    $("#" + id).css({
        "position": "relative",
        "top": "-50px"
    }).animate({
        "opacity": "1",
        "top": "0px"
    }, 500, "easeOutBounce");
    setTimeout(function () {
        $("#" + id).removeClass("errBox__Open");
    }, 500);
} //--------------------------------------------[ OPEN BOX ]

function glyphIcons(icon) {
    if (icon != false) {
        return "<span class='glyphicon glyphicon-" + icon + "' aria-hidden='true'></span> ";
    } else {
        return "";
    }
} //--------------------------------------------[ ICON ]
